Index: messaging/src/main/org/jboss/mq/Connection.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/Connection.java,v
retrieving revision 1.44.2.4
diff -b -B -U8 -r1.44.2.4 Connection.java
--- messaging/src/main/org/jboss/mq/Connection.java	14 Apr 2005 00:13:40 -0000	1.44.2.4
+++ messaging/src/main/org/jboss/mq/Connection.java	26 Aug 2005 23:18:41 -0000
@@ -21,16 +21,17 @@
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 
 import org.jboss.logging.Logger;
 import org.jboss.mq.il.ClientILService;
 import org.jboss.mq.il.ServerIL;
 import org.jboss.util.UnreachableStatementException;
+import org.jboss.util.threadpool.BasicThreadPool;
 
 import EDU.oswego.cs.dl.util.concurrent.ClockDaemon;
 import EDU.oswego.cs.dl.util.concurrent.Semaphore;
 import EDU.oswego.cs.dl.util.concurrent.ThreadFactory;
 
 /**
  * This class implements javax.jms.Connection.
  * 
@@ -85,16 +86,17 @@
 {
    // Constants -----------------------------------------------------
 
    /** The serialVersionUID */
    private static final long serialVersionUID = 87938199839407082L;
 
    /** The threadGroup */
    private static ThreadGroup threadGroup = new ThreadGroup("JBossMQ Client Threads");
+   private static BasicThreadPool threadPool = new BasicThreadPool("Client", threadGroup);
 
    /** The log */
    static Logger log = Logger.getLogger(Connection.class);
 
    /** Whether trace is enabled */
    static boolean trace = log.isTraceEnabled();
 
    /**
@@ -219,19 +221,22 @@
             t.setDaemon(true);
             return t;
          }
       });
    }
 
    public static ThreadGroup getThreadGroup()
    {
-      if (threadGroup.isDestroyed())
-         threadGroup = new ThreadGroup("JBossMQ Client Threads");
-      return threadGroup;
+      return threadPool.getThreadGroup();
+   }
+   
+   public static BasicThreadPool getThreadPool()
+   {
+      return threadPool;
    }
    
    // Constructors --------------------------------------------------
 
    /**
 	 * Create a new Connection
 	 * 
 	 * @param userName the username
@@ -390,33 +395,34 @@
 
       if (trace)
          log.trace("Async deliver requests=" + Arrays.asList(requests) + " " + this);
       
       try
       {
          for (int i = 0; i < requests.length; i++)
          {
+            ReceiveRequest r = requests[i];
             if (trace)
-               log.trace("Processing request=" + requests[i] + " " + this);
+               log.trace("Processing request=" + r + " " + this);
             
-            SpyConsumer consumer = (SpyConsumer) subscriptions.get(requests[i].subscriptionId);
-            requests[i].message.createAcknowledgementRequest(requests[i].subscriptionId.intValue());
+            SpyConsumer consumer = (SpyConsumer) subscriptions.get(r.subscriptionId);
+            r.message.createAcknowledgementRequest(r.subscriptionId.intValue());
 
             if (consumer == null)
             {
-               send(requests[i].message.getAcknowledgementRequest(false));
-               log.debug("WARNING: NACK issued due to non existent subscription " + requests[i].message.header.messageId);
+               send(r.message.getAcknowledgementRequest(AcknowledgementRequest.NACK));
+               log.debug("WARNING: NACK issued due to non existent subscription " + r.message.header.messageId);
                continue;
             }
 
             if (trace)
-               log.trace("Delivering messageid=" + requests[i].message.header.messageId + " to consumer=" + consumer);
+               log.trace("Delivering messageid=" + r.message.header.messageId + " to consumer=" + consumer);
             
-            consumer.addMessage(requests[i].message);
+            consumer.addMessage(r.message);
          }
       }
       catch (Throwable t)
       {
          asynchFailure("Error during async delivery", t);
       }
    }
    /**
Index: messaging/src/main/org/jboss/mq/SpyMessage.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/SpyMessage.java,v
retrieving revision 1.27.6.2
diff -b -B -U8 -r1.27.6.2 SpyMessage.java
--- messaging/src/main/org/jboss/mq/SpyMessage.java	19 Oct 2004 01:11:52 -0000	1.27.6.2
+++ messaging/src/main/org/jboss/mq/SpyMessage.java	26 Aug 2005 23:18:42 -0000
@@ -64,16 +64,31 @@
 
    /**
 	 * JBoss-vendor specific property specifying the limit of redelivery
 	 * attempts of a message. The message will be redelivered a given number of
 	 * times. If not set, the container default is used.
 	 */
    public static final String PROPERTY_REDELIVERY_LIMIT = "JMS_JBOSS_REDELIVERY_LIMIT";
 
+   /** 
+   * JBoss-vendor property name holding original destination.
+   */
+   public static final String PROPERTY_ORIG_DESTINATION = "JBOSS_ORIG_DESTINATION";
+
+   /** 
+   * JBoss-vendor property name holding original expiration value.
+   */
+   public static final String PROPERTY_ORIG_EXPIRATION = "JBOSS_ORIG_EXPIRATION";
+
+   /** 
+   * JBoss-vendor property name holding original message ID value.
+   */
+   public static final String PROPERTY_ORIG_MESSAGEID = "JBOSS_ORIG_MESSAGEID";
+
    /** An object message */
    protected static final byte OBJECT_MESS = 1;
    /** An bytes message */
    protected static final byte BYTES_MESS = 2;
    /** A map message */
    protected static final byte MAP_MESS = 3;
    /** A text message */
    protected static final byte TEXT_MESS = 4;
@@ -295,48 +310,42 @@
                original.header.durableSubscriberID.subscriptionName, original.header.durableSubscriberID.selector);
    }
 
    /**
 	 * Test whether a message has expired
 	 * 
 	 * @return true when expired false otherwise
 	 */
-   public boolean isOutdated()
+   public boolean isExpired()
    {
       if (header.jmsExpiration == 0)
          return false;
       long ts = System.currentTimeMillis();
       return header.jmsExpiration < ts;
    }
 
    /**
     * Actually acknowledge a message
     *
     * @throws JMSException for any error
     */
    public void doAcknowledge() throws JMSException
    {
-      if (session.closed)
-         throw new IllegalStateException("Session is closed.");
       session.doAcknowledge(this, getAcknowledgementRequest(true));
    }
 
    /**
-    * Actually nack a message
+    * Nack an expired message
     *
     * @throws JMSException for any error
     */
-   public void doNegAcknowledge() throws JMSException
+   public void doExpiredAcknowledge() throws JMSException
    {
-      if (session.closed)
-      {
-         throw new IllegalStateException("Session is closed.");
-      }
-      session.doAcknowledge(this, getAcknowledgementRequest(false));
+      session.doAcknowledge(this, getAcknowledgementRequest(AcknowledgementRequest.EACK));
    }
 
    /**
     * Create an acknowledgement request for the message
     */
    public void createAcknowledgementRequest(int subscriptionId)
    {
       ack = new AcknowledgementRequest();
@@ -348,22 +357,33 @@
    /**
     * Get an acknowledgement request for the message
     * 
     * @param isAck true for an ack, false for a nack
     * @throws JMSException for any error
     */
    public AcknowledgementRequest getAcknowledgementRequest(boolean isAck) throws JMSException
    {
+      byte ack = isAck ? AcknowledgementRequest.ACK : AcknowledgementRequest.NACK;
+      return getAcknowledgementRequest(ack);
+   }
+
+   /**
+    * Get an acknowledgement request for the message
+    * 
+    * @param ack AcknowledgementRequest state
+    * @throws JMSException for any error
+    */
+   public AcknowledgementRequest getAcknowledgementRequest(byte ackState) throws JMSException
+   {
       //don't know if we have to copy but to be on safe side...
-      AcknowledgementRequest item = new AcknowledgementRequest();
+      AcknowledgementRequest item = new AcknowledgementRequest(ackState);
       item.destination = ack.destination;
       item.messageID = ack.messageID;
       item.subscriberId = ack.subscriberId;
-      item.isAck = isAck;
       return item;
    }
 
    // Comparable implementation -------------------------------------
 
    public int compareTo(Object o)
    {
       SpyMessage sm = (SpyMessage) o;
@@ -930,19 +950,16 @@
    void checkProperty(String name, Object value) throws JMSException
    {
       if (name == null)
          throw new IllegalArgumentException("The name of a property must not be null.");
 
       if (name.equals(""))
          throw new IllegalArgumentException("The name of a property must not be an empty String.");
 
-      if (Strings.isValidJavaIdentifier(name) == false)
-         throw new IllegalArgumentException("The property name '" + name + "' is not a valid java identifier.");
-
       if (reservedIdentifiers.contains(name))
          throw new IllegalArgumentException("The property name '" + name + "' is reserved due to selector syntax.");
 
       if (name.regionMatches(false, 0, "JMS_", 0, 4))
       {
          if (name.equals(PROPERTY_SCHEDULED_DELIVERY))
          {
             if (!(value instanceof Long))
@@ -958,30 +975,47 @@
             if (!(value instanceof Number))
                throw new JMSException(name + " must be Number: " + value);
          }
          else if (name.equals(PROPERTY_REDELIVERY_LIMIT))
          {
             if (!(value instanceof Number))
                throw new JMSException(name + " must be Number: " + value);
          }
+         else if (name.equals(PROPERTY_ORIG_EXPIRATION))
+         {
+            if (!(value instanceof Long))
+               throw new JMSException(name + " must be Long: " + value);
+         }
+         else if (name.equals(PROPERTY_ORIG_DESTINATION))
+         {
+            // no validation
+         }
+         else if (name.equals(PROPERTY_ORIG_MESSAGEID))
+         {
+            // no validation
+         }
          else
          {
             throw new JMSException("Illegal property name: " + name);
          }
       }
 
       if (name.regionMatches(false, 0, "JMSX", 0, 4))
       {
          if (name.equals("JMSXGroupID"))
             return;
          if (name.equals("JMSXGroupSeq"))
             return;
          throw new JMSException("Illegal property name: " + name);
       }
+
+      if (Strings.isValidJavaIdentifier(name) == false)
+         throw new IllegalArgumentException("The property name '" + name + "' is not a valid java identifier.");
+
    }
 
    /**
 	 * Clear a message
 	 * 
 	 * @throws JMSException for any error
 	 */
    void clearMessage() throws JMSException
Index: messaging/src/main/org/jboss/mq/SpyMessageConsumer.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/SpyMessageConsumer.java,v
retrieving revision 1.33.2.3
diff -b -B -U8 -r1.33.2.3 SpyMessageConsumer.java
--- messaging/src/main/org/jboss/mq/SpyMessageConsumer.java	18 Feb 2005 20:39:17 -0000	1.33.2.3
+++ messaging/src/main/org/jboss/mq/SpyMessageConsumer.java	26 Aug 2005 23:18:42 -0000
@@ -623,21 +623,21 @@
                   }
                   else
                   {
                      if (trace)
                         log.trace("run() message from server mes=" + mes.getJMSMessageID() + " " + this); 
                   }
                }
                mes.session = session;
-               if (mes.isOutdated())
+               if (mes.isExpired())
                {
                   if (trace)
                      log.trace("run() acking expired message mes=" + mes.getJMSMessageID() + " " + this); 
-                  mes.doAcknowledge();
+                  mes.doExpiredAcknowledge();
                   mes = null;
                }
             }
 
             MessageListener thisListener;
             synchronized (stateLock)
             {
                if (!isListening())
@@ -801,21 +801,21 @@
    }
 
    Message preProcessMessage(SpyMessage message) throws JMSException
    {
       message.session = session;
       session.addUnacknowlegedMessage(message);
 
       // Has the message expired?
-      if (message.isOutdated())
+      if (message.isExpired())
       {
          if (trace)
             log.trace("preprocess() acking expired message=" + message.getJMSMessageID() + " " + this);
-         message.doAcknowledge();
+         message.doExpiredAcknowledge();
          return null;
       }
 
       // Should we try to ack before the message is processed?
       if (!isListening())
       {
          if (session.transacted)
          {
@@ -854,21 +854,21 @@
       {
          return listening;
       }
    }
 
    protected void sessionConsumerProcessMessage(SpyMessage message) throws JMSException
    {
       message.session = session;
-      if (message.isOutdated())
+      if (message.isExpired())
       {
          if (trace)
-            log.trace("consumer() acking message in tx message=" + message.getJMSMessageID() + " " + this);
-         message.doAcknowledge();
+            log.trace("consumer() expiring message in tx message=" + message.getJMSMessageID() + " " + this);
+         message.doExpiredAcknowledge();
          return;
       }
       //simply pass on to messageListener (if there is one)
       MessageListener thisListener;
       synchronized (stateLock)
       {
          thisListener = messageListener;
       }
Index: messaging/src/main/org/jboss/mq/SpySession.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/SpySession.java,v
retrieving revision 1.32.2.5
diff -b -B -U8 -r1.32.2.5 SpySession.java
--- messaging/src/main/org/jboss/mq/SpySession.java	14 Apr 2005 00:13:40 -0000	1.32.2.5
+++ messaging/src/main/org/jboss/mq/SpySession.java	26 Aug 2005 23:18:42 -0000
@@ -158,18 +158,20 @@
 	 * API documentation to define Message.acknowledge in the same manner.
 	 * 
 	 * @param message the message to acknowledge
 	 * @param ack the acknowledgement request
 	 * @throws JMSException for any error
 	 */
    public void doAcknowledge(Message message, AcknowledgementRequest ack) throws JMSException
    {
+      if (closed)
+         throw new IllegalStateException("The session is closed");
       //if we are acking, ack all messages consumed by this session
-      if (ack.isAck)
+      if (ack.isAck())
       {
          synchronized (unacknowledgedMessages)
          {
             if (trace)
                log.trace("Acknowledging message " + ack);
 
             //ack the current message
             connection.send(((SpyMessage) message).getAcknowledgementRequest(true));
Index: messaging/src/main/org/jboss/mq/SpyXAResourceManager.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/SpyXAResourceManager.java,v
retrieving revision 1.15.6.1
diff -b -B -U8 -r1.15.6.1 SpyXAResourceManager.java
--- messaging/src/main/org/jboss/mq/SpyXAResourceManager.java	13 Apr 2005 18:43:21 -0000	1.15.6.1
+++ messaging/src/main/org/jboss/mq/SpyXAResourceManager.java	26 Aug 2005 23:18:42 -0000
@@ -235,17 +235,17 @@
          if (state.ackedMessages.size() != 0)
          {
             AcknowledgementRequest job[] = new AcknowledgementRequest[state.ackedMessages.size()];
             job = (AcknowledgementRequest[]) state.ackedMessages.toArray(job);
             transaction.acks = job;
             //Neg Acknowlege all consumed messages
             for (int i = 0; i < transaction.acks.length; i++)
               {
-               transaction.acks[i].isAck = false;
+               transaction.acks[i].ack = AcknowledgementRequest.NACK;
             }
          }
          connection.send(transaction);
       }
       else
       {
          TransactionRequest transaction = new TransactionRequest();
          transaction.xid = xid;
Index: messaging/src/main/org/jboss/mq/il/Invoker.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/Invoker.java,v
retrieving revision 1.3
diff -b -B -U8 -r1.3 Invoker.java
--- messaging/src/main/org/jboss/mq/il/Invoker.java	27 Aug 2003 04:31:29 -0000	1.3
+++ messaging/src/main/org/jboss/mq/il/Invoker.java	26 Aug 2005 23:18:43 -0000
@@ -7,16 +7,17 @@
 package org.jboss.mq.il;
 import javax.jms.Destination;
 
 import javax.jms.JMSException;
 import javax.jms.Queue;
 import javax.jms.TemporaryQueue;
 import javax.jms.TemporaryTopic;
 import javax.jms.Topic;
+import org.jboss.util.threadpool.ThreadPool;
 import org.jboss.mq.AcknowledgementRequest;
 import org.jboss.mq.ConnectionToken;
 import org.jboss.mq.DurableSubscriptionID;
 import org.jboss.mq.SpyTopic;
 import org.jboss.mq.Subscription;
 
 import org.jboss.mq.SpyDestination;
 import org.jboss.mq.SpyMessage;
@@ -30,19 +31,25 @@
  * @author     <a href="pra@tim.se">Peter Antman</a>
  * @version   $Revision: 1.3 $
  * @created   August 16, 2001
  */
 public interface Invoker
 {
 
    /**
+    * Get the thread pool of the server.
+    */ 
+   public ThreadPool getThreadPool();
+
+   /**
     * Get the thread group of the server.
     */ 
    public ThreadGroup getThreadGroup();
+
    /**
     * Gets a clientID from server.
     *
     * @return               The ID value
     * @exception JMSException  Description of Exception
     */
    public String getID()
           throws JMSException;
Index: messaging/src/main/org/jboss/mq/il/ServerILJMXService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/ServerILJMXService.java,v
retrieving revision 1.18
diff -b -B -U8 -r1.18 ServerILJMXService.java
--- messaging/src/main/org/jboss/mq/il/ServerILJMXService.java	5 Mar 2004 12:35:22 -0000	1.18
+++ messaging/src/main/org/jboss/mq/il/ServerILJMXService.java	26 Aug 2005 23:18:43 -0000
@@ -201,17 +201,17 @@
       ctx.unbind(xaConnectionFactoryJNDIRef);
    }
 
    /**
     * @return Description of the Returned Value
     * @exception Exception Description of Exception
     * @throws javax.naming.NamingException if the server is not found
     */
-   public Invoker lookupJMSServer()
+   public Invoker getJMSServer()
    {
       return jmsServer;
    }
 
    /**
     * @return long the period of time in ms to wait between connection pings
     *         factory should be bound to
     * 
Index: messaging/src/main/org/jboss/mq/il/jvm/JVMServerILService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/jvm/JVMServerILService.java,v
retrieving revision 1.14
diff -b -B -U8 -r1.14 JVMServerILService.java
--- messaging/src/main/org/jboss/mq/il/jvm/JVMServerILService.java	29 Aug 2003 02:04:37 -0000	1.14
+++ messaging/src/main/org/jboss/mq/il/jvm/JVMServerILService.java	26 Aug 2005 23:18:43 -0000
@@ -38,17 +38,17 @@
    /**
     *  Used to construct the GenericConnectionFactory (bindJNDIReferences()
     *  builds it)
     *
     * @return     The ServerIL value
     * @returns    ServerIL the instance of this IL
     */
    public ServerIL getServerIL() {
-      return new JVMServerIL( lookupJMSServer() );
+      return new JVMServerIL( getJMSServer() );
       //return null;
    }
 
    /**
     *  Used to construct the GenericConnectionFactory (bindJNDIReferences()
     *  builds it) Sets up the connection properties need by a client to use this
     *  IL
     *
Index: messaging/src/main/org/jboss/mq/il/oil/OILServerILService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/oil/OILServerILService.java,v
retrieving revision 1.30
diff -b -B -U8 -r1.30 OILServerILService.java
--- messaging/src/main/org/jboss/mq/il/oil/OILServerILService.java	22 Apr 2004 15:21:26 -0000	1.30
+++ messaging/src/main/org/jboss/mq/il/oil/OILServerILService.java	26 Aug 2005 23:18:43 -0000
@@ -538,17 +538,17 @@
     *
     * @exception Exception  Description of Exception
     */
    public void startService() throws Exception
    {
       super.startService();
 
       running = true;
-      this.server = lookupJMSServer();
+      this.server = getJMSServer();
 
       // Use the default javax.net.ServerSocketFactory if none was set
       if (serverSocketFactory == null)
          serverSocketFactory = ServerSocketFactory.getDefault();
 
       /* See if the server socket supports setSecurityDomain(SecurityDomain)
       if an securityDomain was specified
       */
Index: messaging/src/main/org/jboss/mq/il/oil2/OIL2ServerILService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/oil2/OIL2ServerILService.java,v
retrieving revision 1.13
diff -b -B -U8 -r1.13 OIL2ServerILService.java
--- messaging/src/main/org/jboss/mq/il/oil2/OIL2ServerILService.java	22 Apr 2004 15:21:25 -0000	1.13
+++ messaging/src/main/org/jboss/mq/il/oil2/OIL2ServerILService.java	26 Aug 2005 23:18:43 -0000
@@ -452,17 +452,17 @@
     *
     * @exception Exception  Description of Exception
     */
    public void startService() throws Exception
    {
       super.startService();
 
       running = true;
-      this.server = lookupJMSServer();
+      this.server = getJMSServer();
 
       // Use the default javax.net.ServerSocketFactory if none was set
       if (serverSocketFactory == null)
          serverSocketFactory = ServerSocketFactory.getDefault();
 
       /* See if the server socket supports setSecurityDomain(SecurityDomain)
       if an securityDomain was specified
       */
Index: messaging/src/main/org/jboss/mq/il/rmi/RMIServerILService.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/rmi/RMIServerILService.java,v
retrieving revision 1.16
diff -b -B -U8 -r1.16 RMIServerILService.java
--- messaging/src/main/org/jboss/mq/il/rmi/RMIServerILService.java	29 Aug 2003 02:04:40 -0000	1.16
+++ messaging/src/main/org/jboss/mq/il/rmi/RMIServerILService.java	26 Aug 2005 23:18:43 -0000
@@ -63,17 +63,17 @@
    /**
     *  Starts this IL, and binds it to JNDI
     *
     * @exception  Exception  Description of Exception
     */
    public void startService() throws Exception
    {
       super.startService();
-      serverIL = new RMIServerIL(lookupJMSServer());
+      serverIL = new RMIServerIL(getJMSServer());
       bindJNDIReferences();
 
    }
 
    /**
     *  Stops this IL, and unbinds it from JNDI
     */
    public void stopService() throws Exception
Index: messaging/src/main/org/jboss/mq/il/uil2/SocketManager.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/uil2/SocketManager.java,v
retrieving revision 1.14.2.4
diff -b -B -U8 -r1.14.2.4 SocketManager.java
--- messaging/src/main/org/jboss/mq/il/uil2/SocketManager.java	9 Mar 2005 21:03:14 -0000	1.14.2.4
+++ messaging/src/main/org/jboss/mq/il/uil2/SocketManager.java	26 Aug 2005 23:18:43 -0000
@@ -14,56 +14,58 @@
 import java.util.Iterator;
 
 import javax.jms.JMSException;
 
 import org.jboss.logging.Logger;
 import org.jboss.mq.il.uil2.msgs.BaseMsg;
 import org.jboss.util.stream.NotifyingBufferedInputStream;
 import org.jboss.util.stream.NotifyingBufferedOutputStream;
+import org.jboss.util.threadpool.ThreadPool;
 
 import EDU.oswego.cs.dl.util.concurrent.ConcurrentHashMap;
 import EDU.oswego.cs.dl.util.concurrent.LinkedQueue;
 import EDU.oswego.cs.dl.util.concurrent.PooledExecutor;
 import EDU.oswego.cs.dl.util.concurrent.SynchronizedBoolean;
 import EDU.oswego.cs.dl.util.concurrent.ThreadFactory;
+import EDU.oswego.cs.dl.util.concurrent.SynchronizedInt;
 
 /** Used to manage the client/server and server/client communication in an
  * asynchrounous manner.
  *
  * @todo verify the pooled executor config
  *
  * @author  Scott.Stark@jboss.org
  * @version $Revision: 1.14.2.4 $
  */
 public class SocketManager
 {
    private static Logger log = Logger.getLogger(SocketManager.class);
 
    private static final int STOPPED = 0;
    private static final int STARTED = 1;
    private static final int STOPPING = 2;
-   private static int taskID = 0;
+   private static SynchronizedInt taskID = new SynchronizedInt(0);
 
    /** The socket created by the IL layer */
    private Socket socket;
    /** The input stream used by the read task */
    private ObjectInputStream in;
    /** The buffering for output */
    NotifyingBufferedInputStream bufferedInput;
    /** The output stream used by the write task */
    private ObjectOutputStream out;
    /** The buffering for output */
    NotifyingBufferedOutputStream bufferedOutput;
    /** The write task thread */
    private Thread writeThread;
    /** The read task thread */
    private Thread readThread;
    /** The thread pool used to service incoming requests */
-   PooledExecutor pool;
+   private ThreadPool pool;
    /** The flag used to control the read loop */
    private int readState = STOPPED;
    /** The flag used to control the write loop */
    private int writeState = STOPPED;
    /** Used for constrolling the state */
    private SynchronizedBoolean running = new SynchronizedBoolean(false);
    /** The queue of messages to be processed by the write task */
    private LinkedQueue sendQueue;
@@ -85,45 +87,34 @@
       replyMap = new ConcurrentHashMap();
       trace = log.isTraceEnabled();
    }
 
    /** Start the read and write threads using the given thread group and
     * names of "UIL2.SocketManager.ReadTask" and "UIL2.SocketManager.WriteTask".
     * @param tg the thread group to use for the read and write threads.
     */
-   public void start(ThreadGroup tg)
+   public void start(ThreadPool pool, ThreadGroup tg)
    {
       if (trace)
          log.trace("start called", new Exception("Start stack trace"));
 
+      this.pool = pool;
+
       InetAddress inetAddr = socket.getInetAddress();
       String ipAddress = (inetAddr != null) ? inetAddr.getHostAddress() : "<unknown>";
       ipAddress += ":" + socket.getPort();
-      if (pool == null)
-      {
-         // TODO: Check the validity of this config
-         pool = new PooledExecutor(5);
-         pool.setMinimumPoolSize(1);
-         pool.setKeepAliveTime(1000 * 60);
-         pool.runWhenBlocked();
-         String id = "SocketManager.MsgPool@"+
-            Integer.toHexString(System.identityHashCode(this))
-            + " client=" +  ipAddress;
-         pool.setThreadFactory(new UILThreadFactory(id));
-      }
 
-      taskID++;
+      int id = taskID.increment();
       ReadTask readTask = new ReadTask();
-      readThread = new Thread(tg, readTask, "UIL2.SocketManager.ReadTask#" + taskID + " client=" +  ipAddress);
+      readThread = new Thread(tg, readTask, "UIL2.SocketManager.ReadTask#" + id + " client=" +  ipAddress);
       readThread.setDaemon(true);
 
-      taskID++;
       WriteTask writeTask = new WriteTask();
-      writeThread = new Thread(tg, writeTask, "UIL2.SocketManager.WriteTask#" + taskID + " client=" + ipAddress);
+      writeThread = new Thread(tg, writeTask, "UIL2.SocketManager.WriteTask#" + id + " client=" + ipAddress);
       writeThread.setDaemon(true);
       
       synchronized (running)
       {
          readState = STARTED;
          writeState = STARTED;
          running.set(true);
       }
@@ -144,21 +135,16 @@
             readThread.interrupt();
          }
          if (writeState == STARTED)
          {
             writeState = STOPPING;
             writeThread.interrupt();
          }
          running.set(false);
-         if (pool != null)
-         {
-            pool.shutdownNow();
-            pool = null;
-         }
       }
    }
 
    /** Set the callback handler for msgs that were not originated by the
     * socket manager. This is any msgs read that was not sent via the
     * sendMessage method.
     *
     * @param handler
@@ -298,20 +284,18 @@
                {
                   msg = BaseMsg.createMsg(msgType);
                   msg.setMsgID(msgID);
                   msg.read(in);
                   if (trace)
                      log.trace("Read new msg: " + msg);
 
                   // Handle the message
-                  if (pool == null)
-                     break;
                   msg.setHandler(this);
-                  pool.execute(msg);
+                  pool.run(msg);
                }
                else
                {
                   if (trace)
                      log.trace("Found replyMap msg: " + msg);
                   msg.setMsgID(msgID);
                   try
                   {
Index: messaging/src/main/org/jboss/mq/il/uil2/UILServerIL.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/il/uil2/UILServerIL.java,v
retrieving revision 1.7.2.3
diff -b -B -U8 -r1.7.2.3 UILServerIL.java
--- messaging/src/main/org/jboss/mq/il/uil2/UILServerIL.java	15 Jul 2005 20:40:00 -0000	1.7.2.3
+++ messaging/src/main/org/jboss/mq/il/uil2/UILServerIL.java	26 Aug 2005 23:18:44 -0000
@@ -670,17 +670,17 @@
       }
 
       socket.setTcpNoDelay(enableTcpNoDelay);
       if (soTimeout != 0)
          socket.setSoTimeout(soTimeout);
       socketMgr = new SocketManager(socket);
       socketMgr.setBufferSize(bufferSize);
       socketMgr.setChunkSize(chunkSize);
-      socketMgr.start(Connection.getThreadGroup());
+      socketMgr.start(Connection.getThreadPool(), Connection.getThreadGroup());
    }
 
    /**
     * Used to close the current connection with the server
     *
     */
    protected void destroyConnection()
    {
